const tiposOficio = [
	{ 
		'procedure': PROCEDIMIENTO_BAJA,
		'procedureDesc': PROCEDIMIENTO_BAJA_DESC
	},
	{ 
		'procedure': PROCEDIMIENTO_MODIFICACION,
		'procedureDesc': PROCEDIMIENTO_MODIFICACION_DESC
	},
	{ 
		'procedure': PROCEDIMIENTO_REVISION,
		'procedureDesc': PROCEDIMIENTO_REVISION_DESC
	},
	{ 
		'procedure': PROCEDIMIENTO_INFORME,
		'procedureDesc': PROCEDIMIENTO_INFORME_DESC
	}
];

let currentOficio = '';
let url_pago = '';


jQuery(function ($) {
	
	initRupI18nPromise.then(function () {		
		
		
		initComponentes();
		//iniciarDialogDocumento();
		iniciarUpload();
		Ad74aUtils.soloNumericos();
		
		//Iniciamos la sesion
		$.rup_ajax({
        	url: $.rup.CTX_PATH +"inicioOficio/documentosOficio/clear",
            type: "GET",                	            
            success: function (){
        		console.log("Session cleared");                    
          	}
        });	
		//cargamos la tabla
		cargarTablaDocumentos();
		
		if($("#idProcedimiento00_observacionesOficio_detail_table").val() == '0087007'){
			
			// Inicializar el feedback
			try {
				$("#liquidaciones_feedback").rup_feedback("destroy");
			} catch (error) {}

			$("#liquidaciones_feedback").rup_feedback(
				{
					type: "ok",
					block: true,
					//delay: 3000,
					fadeSpeed: 600,
				}
			);
			$("#liquidaciones_feedback").rup_feedback("set", $.rup.i18n.app.avisos.notificacionLiquidacion,"alert");
			url_pago=$("#verPago").attr("href");
			
			if($("#idLiquidacion00").val()!=null){
				//enrutar el enlace
				$("#verPago").attr("href",url_pago+$("#idLiquidacion00").val());
			}else{
				$("#layerEnlaceverPago").hide();
			}
			
			$.rup_ajax({
	        	url: $.rup.CTX_PATH +"inicioOficio/liquidaciones/clear",
	            type: "GET",                	            
	            success: function (){
	        		console.log("Session cleared");                    
	          	}
	        });	
			cargarTablaLiquidaciones();
			
			$('#fEmision00_liquidaciones_dialog_table').rup_date({
				mask: 'dd/mm/yyyy',
				disabled : true
			});
			$('#fLimitePago00_liquidaciones_dialog_table').rup_date({
				mask: 'dd/mm/yyyy',
				disabled : true
			});
			Ad74aUtils.formatoMoneda();
			$("#buscarLiquidacionBtn").hide();
			$("#canalesOficio option[value=4]").click();
			$("#canalesOficio option[value='4']").attr("selected",true);
			
		}
				
		$("#inicioOficio_form [ruptype='date']").blur(function(elem) { 

			if(!$(elem.target).valid()){
	            $(elem.target).val('')
	        }

		});
		FN_controlCanalNot();
		
	});

	
	
});

/**
 * Inicializar los componentes según el tipo de procedimiento
 */
const initComponentes = () => {
	const searchParams = new URLSearchParams(window.location.search);
	console.log("INITCOMPONENTES");
	
	// Borrar los hidden generados con el <form:checkbox/>
	$("input[name='_autorizacionCon00']").remove();
	
	$("#iniciarOficio_detail_button_save").click(function (){
		Ad74aUtils.openConfirmDialog(
				'dialogConfirm', 
				$.rup.i18n.app.inicioOficio.iniciarOficio, 
				$.rup.i18n.app.inicioOficio.tramitarInicio,  
				[
		        	{
		                text: $.rup.i18n.app.botonera.cancelar,
		                click: function () { 
		                    $('#dialogConfirm').rup_dialog('close'); 
		                },
		                btnType: $.rup.dialog.LINK
		            },
			        {
			            text: $.rup.i18n.app.botonera.aceptar,
			            id: "btnAceptar",
			            class: 'btn-material btn-material-primary-high-emphasis',
			            click: function () { 
			            	$('#dialogConfirm').rup_dialog('close'); 
			            	iniciarOficio();
			            }
			        }
		        ]
			);
	});
	
	
    
	Ad74aUtils.hacerPlegable();
	FN_controlMaxDni();
	$("#tipoIden00_informes_dialog_table").on("change", function() { 
		FN_controlMaxDni();
	});
	FN_controlMaxDniConyuge();
	$("#tipoIdenCon00_tabSolicitud_detail_table").on("change", function() { 
		FN_controlMaxDni();
	});

	FN_controlRadioPisoTutelado();
	$('[name="perfiles.pisoTutelado07"]').change(FN_controlRadioPisoTutelado);
	
	  
	  
	
	
	// Inicializar el feedback
	try {
		$("#iniciosOficio_feedback").rup_feedback("destroy");
	} catch (error) {}

	$("#iniciosOficio_feedback").rup_feedback(
		{
			type: "ok",
			block: false 
		}
	);
	//Validar JS 
	jQuery.validator.addMethod("validarIdentificador", function(value, element,a) {
		 return Ad74aUtils.validarCampoIdentificador($("#tipoIdenCon00_tabSolicitud_detail_table").val(),$("#identificadorCon00_tabSolicitud_detail_table").val());	
	 }, $.rup.i18n.app.errores.dniNoValido);
 
	
	jQuery.validator.addMethod("validarDNIIdentificador", function(value, element,a) {
		if($('#tipoIden00_informes_dialog_table').val()!='4'){
			return Ad74aUtils.validarCampoIdentificador($("#tipoIden00_informes_dialog_table").val(),$("#dniSolicitante_informes_dialog_table").val());	
		 }return true;
	},$.rup.i18n.app.errores.dniNoValido);
	
	jQuery.validator.addMethod("checkPisosTutelados", function(value, element,a) {			
		return ($("#SI_pisoTutelado07_tabSolicitud_detail_table").prop("checked") && $("#idPiso32_tabSolicitud_detail_table").val() != null && $("#idPiso32_tabSolicitud_detail_table").val() != '') || $("#NO_pisoTutelado07_tabSolicitud_detail_table").prop("checked") ;						
	 },$.rup.i18n.base.rup_validate.messages.required);
	jQuery.validator.addMethod("requiredCPNot", function(value, element, params) {
		 if($("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked')){
			 if(params.length != 2) {
				 return false;
			 }
			 const current 	= $("[name='"+ params[0]+"']").val();
			 const compareTo = $("[name='"+ params[1]+"']").val();
			 return (current!= "" && compareTo == "") || compareTo != "";	
		 }
		 return true;
	 }, $.rup.i18n.base.rup_validate.messages.required);
	
	 jQuery.validator.addMethod("requiredPortalNot", function(value, element,a) {
		 if($("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked')){
			 if(element.id == 'dirNotportal06_detail_table' && ($("#dirNotportal06_detail_table").val() == '' || $("#dirNotidportal06_detail_table").rup_combo("getRupValue") != '')){
				 return false;
			 }else if(element.id == 'dirNotidportal06_detail_table' && $("#dirNotidportal06_detail_table").rup_autocomplete("getRupValue") == '' && $("#dirNotportal06_detail_table").val() == '' ){
				 return false;
			 }else {
				 return true;
			 }
		 }			 		 
		 return true;
	 },$.rup.i18n.base.rup_validate.messages.required);
	 jQuery.validator.addMethod("requiredCalleNot", function(value, element,a) {
		 if($("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked')){
			 if(element.id == 'dirNotcalle06_detail_table' && ($("#dirNotcalle06_detail_table").val() != ''  ||  $("#dirNotidcalle06_detail_table").rup_autocomplete("getRupValue") !='')){
				 return false;
			 }else if(element.id == 'dirNotidcalle06_detail_table' && $("#dirNotidcalle06_detail_table").rup_autocomplete("getRupValue") != ''  || $("#dirNotcalle06_detail_table").val()!= '' ){
				 return false;
			 }else {
				 return true;
			 }
		 }			 
		 return true;
	 },$.rup.i18n.base.rup_validate.messages.required);
	const validacionOficios={
			feedback:$("#iniciosOficio_feedback"),
			liveCheckingErrors: false,
			showFieldErrorAsDefault: true,
			showErrorsInFeedback: true,
			showFieldErrorsInFeedback: true,
			rules:{
//				  "direccionNotif.localidad06":{ /*requiredNot : true,*/requiredCPNot: ["direccionNotif.localidad06", "direccionNotif.idLocalidad06"]},
//				  "direccionNotif.idLocalidad06":{ /*requiredNot : true,*/requiredCPNot: ["direccionNotif.idLocalidad06", "direccionNotif.localidad06"]},
				  "direccionNotif.calle06_label":{ requiredCalleNot : true,requiredCPNot: ["direccionNotif.calle06", "direccionNotif.idCalle06"]},
				  "direccionNotif.idCalle06_label":{requiredCalleNot : true ,requiredCPNot: ["direccionNotif.idCalle06", "direccionNotif.calle06"]},
				  "direccionNotif.portal06_label":{requiredPortalNot : true ,requiredCPNot: ["direccionNotif.portal06", "direccionNotif.idPortal06"] },
				  "direccionNotif.idPortal06_label":{ requiredPortalNot : true, requiredCPNot: ["direccionNotif.idPortal06", "direccionNotif.portal06"]},
				  "solicitantes.identificador01":{validarDNIIdentificador:true},
				  "solicitantes.tipoIdentificador01": {required: true},
				  "identificadorCon00":{validarIdentificador:true},
				  "fBaja00":{required:true,date:true},
				  "idiomaNot00":{required:true},
				  "idTipoNot00":{required:true},
				  "canalNot00":{required:true},
				  "perfiles.pisoTutelado07" : {checkPisosTutelados: true},
			      "emailNot00":{email:true},	
			      "direcciones.idProvincia06_label":{required:true},
			      "direcciones.idMunicipio06_label":{required:true},
			      "direcciones.idCalle06_label":{required:true},
			      "direccionNotif.cp06":{required:true},
			      "direccionNotif.idProvincia06_label":{
			    	  required:function(){
			    		  return $("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked');
			    	  }
			      },
			      "direccionNotif.idMunicipio06_label":{
			    	  required:function(){
			    		  return $("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked');
			    	  }
			      },
			      "direccionNotif.localidad06":{ 
			    	  required:function(){
			    		  return $("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked') && $("[name='direccionNotif.idLocalidad06_label']").val()=='';
			    	  }
			      },       
				  "direccionNotif.idLocalidad06_label":{
			    	  required:function(){
			    		  return $("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked') && $("[name='direccionNotif.localidad06']").val()=='';
			    	  }
			      },
			      "direccionNotif.calle06":{ 
			    	  required:function(){
			    		  return $("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked') && $("[name='direccionNotif.idCalle06_label']").val()=='';
			    	  }
			      },   
				  "direccionNotif.idCalle06_label":{
					  required:function(){
						  return $("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked') && $("[name='direccionNotif.calle06']").val()=='';
						  }
			      }
			     
			}
	};
	
	
	$("#inicioOficio_form").rup_validate(validacionOficios);
	$( "#dniSolicitante_informes_dialog_table" ).on( "focusin", function() {
		
	});
	$('#dniSolicitante_informes_dialog_table').blur(function(){
		$("#inicioOficio_form").validate().element('#tipoIden00_informes_dialog_table');
		$("#inicioOficio_form").validate().element('#dniSolicitante_informes_dialog_table');
		if($("#dniSolicitante_informes_dialog_table").valid()){
			buscarSolicitante();	
		}else{
			$('#nombre01_informes_dialog_table').val("");
			$('#apellido101_informes_dialog_table').val("");
			$('#apellido201_informes_dialog_table').val("");
			$("#tfnoNot00_tabSolicitud_detail_table").val("");
			$("#dirNotcp06_detail_table").val("");
			$("#dirNotportal06_detail_table").val("");
			$("#dirNotcalle06_detail_table").val("");
			$("#dirNotlocalidad06_detail_table").val("");
			$("#dirNotescalera06_detail_table").val("");
			$("#dirNotpiso06_detail_table").val("");
			$("#dirNotletra06_detail_table").val("");
			iniciarDireccionNotificacion(expedienteJSON.direccionNotif, "dirNot");
		}
		
	
		
	});
	$('#identificadorCon00_tabSolicitud_detail_table').blur(function(){
		$("#inicioOficio_form").validate().element('#tipoIdenCon00_tabSolicitud_detail_table');
		$("#inicioOficio_form").validate().element('#identificadorCon00_tabSolicitud_detail_table');
		
	});
	
	
	
	$("#tipoIden00_informes_dialog_table").rup_combo({
		loadFromSelect:true,
		width: 'auto',
        ordered: false,
		customClasses: ['select-material'],
		rowStriping: true,
		blank: '',
		onLoadSuccess: function(obj){
			let comboValue = $('#tipoIden00_informes_dialog_table').find(":selected").val();
			$("#tipoIden00_informes_dialog_table").rup_combo("clear");
			$("#tipoIden00_informes_dialog_table").rup_combo("select", comboValue);
		}
	});
	
	let valor = $( "#idMotivoBaja00_observacionesOficio_detail_table" ).val()
	  if(valor == '16'){
		  $('#observaciones00_observacionesOficio_detail_table').attr("required","required");
	  }else{
		  $('#observaciones00_observacionesOficio_detail_table').removeAttr("required");
	  }
	$( "#idMotivoBaja00_observacionesOficio_detail_table" ).on( "change", function() {
		  let valor = $( "#idMotivoBaja00_observacionesOficio_detail_table" ).val()
		  if(valor == '16'){
			  $('#observaciones00_observacionesOficio_detail_table').attr("required","required");
		  }else{
			  $('#observaciones00_observacionesOficio_detail_table').removeAttr("required");
		  }
		} );
	

	FN_controlConyuge();
	
	$("[name='exencionSol00']").change(FN_controlConyuge);
	$("[name='canalNot00']").change(FN_controlCanalNot);
	
	function FN_controlMaxDni(){
		if($("#tipoIden00_informes_dialog_table").val() == '1' || $("#tipoIden00_informes_dialog_table").val() == '2'){
			$("#dniSolicitante_informes_dialog_table").attr('maxlength',9);
		}else if($("#tipoIden00_informes_dialog_table").val() == '3'){
			$("#dniSolicitante_informes_dialog_table").attr('maxlength',10);
		}else{
			$("#dniSolicitante_informes_dialog_table").attr('maxlength',15);
		}
	}
	function FN_controlConyuge(){
		
		// Solo existe la capa en el oficio de revisión y hay que mostrar la siempre
//		$("#conyugeGrupo").show();
//		if($("#N_exencionSol00_tabSolicitud_detail_table").is(':checked')) {
//			$("#conyugeGrupo").hide();			
//		}
		
	}
	function FN_controlMaxDniConyuge(){
		if($("#tipoIdenCon00_tabSolicitud_detail_table").val() == '1' || $("#tipoIdenCon00_tabSolicitud_detail_table").val() == '2'){
			$("#identificadorCon00_tabSolicitud_detail_table").attr('maxlength',9);
		}else if($("#tipoIdenCon00_tabSolicitud_detail_table").val() == '3'){
			$("#identificadorCon00_tabSolicitud_detail_table").attr('maxlength',10);
		}else{
			$("#identificadorCon00_tabSolicitud_detail_table").attr('maxlength',15);
		}
	}
	
	function FN_controlTipoNot00(){
		if($("#T_idTipoNot00_tabSolicitud_detail_table").is(':checked')){
			
			
			$("#divDireccionNot").hide();
//			$('#dirNotcp06_detail_table').removeAttr("required");
//			$('#dirNotidprovincia06_detail_table_label').removeAttr("required");
//			$('#dirNotidmunicipio06_detail_table_label').removeAttr("required");
//			$('#dirNotidlocalidad06_detail_table_label').removeAttr("required");
//			$('#dirNotidcalle06_detail_table_label').removeAttr("required");
			$("label[for='dirNotcp06_detail_table']").removeClass('obligatorio');
			$("label[for='dirNotidprovincia06_detail_table_label']").removeClass('obligatorio');
			$("label[for='dirNotidmunicipio06_detail_table_label']").removeClass('obligatorio');
			$("label[for='dirNotidlocalidad06_detail_table_label']").removeClass('obligatorio');
			$("label[for='dirNotlocalidad06_detail_table']").removeClass('obligatorio');
			$("label[for='dirNotidcalle06_detail_table_label']").removeClass('obligatorio');
			$("label[for='dirNotcalle06_detail_table']").removeClass('obligatorio');
			
		}else if($("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked')){
			
			
			$("#divDireccionNot").show();
//			$('#dirNotcp06_detail_table').attr("required","required");
//			$('#dirNotidprovincia06_detail_table_label').attr("required","required");
//			$('#dirNotidmunicipio06_detail_table_label').attr("required","required");
//			//$('#dirNotidlocalidad06_detail_table').attr("required","required");
//			//$('#dirNotidcalle06_detail_table').attr("required","required");
			$("label[for='dirNotcp06_detail_table']").addClass('obligatorio');
			$("label[for='dirNotidprovincia06_detail_table_label']").addClass('obligatorio');
			$("label[for='dirNotidmunicipio06_detail_table_label']").addClass('obligatorio');
			$("label[for='dirNotidcalle06_detail_table_label']").addClass('obligatorio');
			$("label[for='dirNotcalle06_detail_table']").addClass('obligatorio');
			
			$("label[for='dirNotidlocalidad06_detail_table_label']").addClass('obligatorio');
			$("label[for='dirNotlocalidad06_detail_table']").addClass('obligatorio');
		}
//		}else{
//			$("#divDireccionNot").hide();
//			
//			$("#emailNotGrupo").hide();
//			$("#tlfnNotGrupo").hide();
//			$('#dirNotcp06_detail_table').removeAttr("required");
//			$('#dirNotidprovincia06_detail_table').removeAttr("required");
//			$('#dirNotidmunicipio06_detail_table').removeAttr("required");
//			$('#dirNotidlocalidad06_detail_table').removeAttr("required");
//			$('#dirNotidcalle06_detail_table').removeAttr("required");
//		}
			
		
	}

//	$("label[for='dirNotidprovincia06_detail_table_label']").addClass('obligatorio');
//	$("label[for='dirNotidmunicipio06_detail_table_label']").addClass('obligatorio');
//	$("label[for='dirNotidlocalidad06_detail_table_label']").addClass('obligatorio');
//	$("label[for='dirNotidcalle06_detail_table_label']").addClass('obligatorio');
//	$("label[for='dirContactocp06_detail_table']").addClass('obligatorio');
//	$("label[for='dirContactoidprovincia06_detail_table_label']").addClass('obligatorio');
//	$("label[for='dirContactoidmunicipio06_detail_table_label']").addClass('obligatorio');
//	$("label[for='dirContactolocalidad06_detail_table']").addClass('obligatorio');
//	$("label[for='dirContactoidcalle06_detail_table_label']").addClass('obligatorio');
//	$("label[for='dirContactocalle06_detail_table']").addClass('obligatorio');
	
	
	
//Bloque de direcciones
	$("#cp06_tabSolicitud_detail_table").on("keyup", function(){
		var input = 'cp06_tabSolicitud_detail_table';
		var cp = $('#'+input).val();
		Ad74aUtils.empieceComprobarCP(cp,input);
	});
	FN_controlTipoNot00();
	$("[name='idTipoNot00']").change(FN_controlTipoNot00);
	$("#cp06Not_tabSolicitud_detail_table").on("change", function(){
		$.rup_ajax({
			url: $.rup.CTX_PATH + "nora/findByCodPostal",
			type: "GET",
			data: { "cp06": this.value },
			dataType: 'json',
			contentType: 'application/json',
			success: function (mapaRespuesta){
				if(mapaRespuesta != null && mapaRespuesta.length > 0){								
					//$("#idprovincia06_tabSolicitud_detail_table").attr("value", mapaRespuesta[0].codProvincia);
					console.log("Esta es la provincia --> " + mapaRespuesta[0].codProvincia);
					$("#idprovincia06Not_tabSolicitud_detail_table").attr("value",mapaRespuesta[0].codProvincia);
					cargarCombosDatosDomicilioNora(true);
				}
			},
			error: function(error){	
				console.log(error);	
			}
		});
		
	});
	cargarCombosDatosDomicilioNora(false);
	$("#cp06_tabSolicitud_detail_table").on("change", function(){
		$.rup_ajax({
			url: $.rup.CTX_PATH + "nora/findByCodPostal",
			type: "GET",
			data: { "cp06": $("#cp06_tabSolicitud_detail_table").val() },
			dataType: 'json',
			contentType: 'application/json',
			success: function (mapaRespuesta){
				if(mapaRespuesta != null && mapaRespuesta.length > 0){								
					//$("#idprovincia06_tabSolicitud_detail_table").attr("value", mapaRespuesta[0].codProvincia);
					console.log("Esta es la provincia --> " + mapaRespuesta[0].codProvincia);
					$("#idprovincia06_tabSolicitud_detail_table").attr("value",mapaRespuesta[0].codProvincia);
					cargarCombosModificacion(true);
				}
			},
			error: function(error){	
				console.log(error);	
			}
		});
		
	});
	
	if($("#idProcedimiento00_observacionesOficio_detail_table").val() == '0087005'){
		$('#preguntaExencion').hide();
		$('#S_exencionSol00_tabSolicitud_detail_table').click();
		$("#tipoIdenCon00_tabSolicitud_detail_table").rup_combo({
			loadFromSelect:true,
			width: 'auto',
	        ordered: false,
			customClasses: ['select-material'],
			rowStriping: true,
			blank: '',
			onLoadSuccess: function(obj){
				let comboValue = $('#tipoIdenCon00_tabSolicitud_detail_table').find(":selected").val();
				$("#tipoIdenCon00_tabSolicitud_detail_table").rup_combo("clear");
				$("#tipoIdenCon00_tabSolicitud_detail_table").rup_combo("select", comboValue);
			}
		});
		/*
		 * Controlar que los campos del conyuge se vuelvan required 
		 */
		let apellido1 = $('#apellido1Con00_tabSolicitud_detail_table');
        let apellido2 = $('#apellido2Con00_tabSolicitud_detail_table');
        let nombre = $('#nombreCon00_tabSolicitud_detail_table');
        let identificador = $('#identificadorCon00_tabSolicitud_detail_table');
        let autorizacion = $('#autorizacionCon00_tabSolicitud_detail_table');
        
        
        apellido1.change(comprobarCamposLlenos);
        apellido2.change(comprobarCamposLlenos);
        nombre.change(comprobarCamposLlenos);
        identificador.change(comprobarCamposLlenos);
        autorizacion.change(comprobarCamposLlenos);
        
	
	}
	if($("#idProcedimiento00_observacionesOficio_detail_table").val() == '0087003'){

		$('#fBaja00_observacionesOficio_detail_table').rup_date({
					yearRange: 'c-100:c+100',
			        showButtonPanel: true,
			        showOtherMonths: true,
			        mask: 'dd/mm/yyyy'
			    });
		
		$("#idMotivoBaja00_observacionesOficio_detail_table").rup_combo({
			loadFromSelect:true,
			width: 'auto',
	        ordered: true,
			customClasses: ['select-material'],
			rowStriping: true,
			blank: '',
			onLoadSuccess: function(obj){
				//let comboValue = $('#idMotivoBaja00_observacionesOficio_detail_table').find(":selected").val();
				//$("#idMotivoBaja00_observacionesOficio_detail_table").rup_combo("clear");
				//$("#idMotivoBaja00_observacionesOficio_detail_table").rup_combo("select", comboValue);
			},
			//selected: ''
		});
		if(!searchParams.has('avisos')){
			$("#fBaja00_observacionesOficio_detail_table").rup_date("setDate", new Date());
		}
		
	}
	function comprobarCamposLlenos(){
		let apellido1 = $('#apellido1Con00_tabSolicitud_detail_table');
        let apellido2 = $('#apellido2Con00_tabSolicitud_detail_table');
        let nombre = $('#nombreCon00_tabSolicitud_detail_table');
        let identificador = $('#identificadorCon00_tabSolicitud_detail_table');
        let autorizacion = $('#autorizacionCon00_tabSolicitud_detail_table');
        let apellido1Value = $('#apellido1Con00_tabSolicitud_detail_table').val();
        let apellido2Value = $('#apellido2Con00_tabSolicitud_detail_table').val();
        let nombreValue = $('#nombreCon00_tabSolicitud_detail_table').val();
        let identificadorValue = $('#identificadorCon00_tabSolicitud_detail_table').val();
        let autorizacionValue = $('#autorizacionCon00_tabSolicitud_detail_table').prop('checked');
	        if (apellido1Value !== '' || apellido2Value || '' || nombreValue !== '' || identificadorValue !== '' || autorizacionValue !== false) {
	           //algun campo esta lleno asique lo ponemos en required
	        	apellido1.prop('required', 'required');
	            apellido2.prop('required', 'required');
	            nombre.prop('required', 'required');
	            identificador.prop('required', 'required');
	        } else {
	            //No hay campos llenos asique quitamos los required
	        	  apellido1.removeAttr('required');
	              apellido2.removeAttr('required');
	              nombre.removeAttr('required');
	              identificador.removeAttr('required');
	        }
	}
	cargarCombosModificacion(false);
	
	$("#canalesOficio").rup_combo({
		loadFromSelect:true,
		width: 'auto',
        ordered: false,
		customClasses: ['select-material'],
		rowStriping: true,
		blank: '',
		onLoadSuccess: function(obj){
			
			if(searchParams.has('avisos')){
				$("#documento_table").attr("data-url-base", $.rup.CTX_PATH  + "inicioOficio/documentosOficio/"+searchParams.get('avisos') );
				$('#canalesOficio').rup_combo('select','1' );
			}else{
				$("#documento_table").attr("data-url-base", $.rup.CTX_PATH  + "inicioOficio/documentosOficio/0");
			}
		}
	});
	
	$('#nombre01_informes_dialog_table').prop("disabled",true);
	$('#apellido101_informes_dialog_table').prop("disabled",true);
	$('#apellido201_informes_dialog_table').prop("disabled",true);
	
	
	
	 $("#buscarSolicitanteBtn").on('click', () => {
		 
		  
			  
		  
		
	 });
	 

	 
	 const procedureID = $("#idProcedimientoOficio").val();
		 // Acción telemática de solicitud   
		 const idActionTelem = 1;
	   
	    $("#idTipoDoc_tipificar_oficios").rup_combo({
			source: $.rup.CTX_PATH + 'combo/getRolDocuments?procedureID='+procedureID+'&idActionTelem'+idActionTelem+'&roleID=undefined',
			sourceParam: {value: "value", label:idioma == 'es' ? "descripcionEs" : "descripcionEu"},
			loadFromSelect:false,	
			rowStriping: true,
			width: 'auto',
			customClasses: ['select-material'],
			onLoadSuccess: function(obj){
				console.log("Añadir solicitud");
				$("#idTipoDoc_tipificar_oficios").prepend("<option value=''>---</option>");
				// Ocultar la solicitud
				$("#idTipoDoc_tipificar_oficios option[value='ejgv_d_solicitud.0.0']").remove();
				UploadFile.disabled("documento", true);
				$("#idTipoDoc_tipificar_oficios").rup_combo('refresh');
				$("#idTipoDoc_tipificar_oficios").rup_combo('select','');
				
			},
			change: function(obj) {
				if($("#idTipoDoc_tipificar_oficios").val() != '') {
					UploadFile.disabled("documento", false);
				}else {
					UploadFile.disabled("documento", true);
				}
			}
		});	
	    
	    
	    jQuery.validator.addMethod("validarIdentificador", function(value, element,a) {
			 return Ad74aUtils.validarCampoIdentificador($("#tipoIdenCon00_tabSolicitud_detail_table").val(),$("#identificadorCon00_tabSolicitud_detail_table").val());	
		 }, $.rup.i18n.app.errores.dniNoValido);

			const documentos_table= $("#documentosbantel");
			
			const cargarDocumentosTelematica = ( entrada, esSolicitud ) => {
				
				$("#documentosBanTel_filter_form #idEntrada15_filter_table_from").val(entrada.idEntrada14);		
				const documentos_table= $("#documentosbantel");
				
				try {
					$("#documentosbantel").DataTable().destroy();
				} catch (error) {}
					
				const tipificar_dialog = $("#tipificar_documentosTelematico_dialog");
				const tipificar_dialog_feedback = $("#rup_feedback_tipificar_documentos");			
				
				const getColumnsModel = function(){
					const getColumnModel = function(name, index, editable, hidden){
						return {
							name: name,
							index: index,
							editable: editable,
							hidden: hidden
						}
					};	
					const columnsModel = [];
					columnsModel.push(getColumnModel( "roleid15",  "roleid02", false, false));
					columnsModel.push(getColumnModel( "roleName",  "roleName", false, false));
					columnsModel.push(getColumnModel( "roleNameEs15",  "roleNameEs15", false, false));
					columnsModel.push(getColumnModel( "roleNameEu15",  "roleNameEu15", false, false));
					columnsModel.push(getColumnModel( "nombreDoc15",  "nombreDoc15", false, false));
					columnsModel.push(getColumnModel( "idEntrada15",  "idEntrada15", false, false));
					columnsModel.push(getColumnModel( "idDocBanTel15",  "idDocBanTel15", false, false));
					return columnsModel;
				};
				
				const getColumnsDefs = function(){
					const columnsDefs = [
					      { "targets": 1,
			    		    "render": function(data, type, rowData, settings){			           
			    		    	if(rowData.oiddokusi15){
			    		    		return "<a href='javascript:$.downloadDocument(\"telematica\",\"" + rowData.oiddokusi15 + "\",\""+rowData.nombreDoc15+ "\");'>" + data + "</a>";					   
			   	    		 	} 
			    		    }
					      }
					   ]
					return columnsDefs;
				};
				
				const getCustomButtons = function(){
				  const customButons = [];	
				  const tipificarButton = {
						text: function () {
							return $.rup.i18n.app.botonera.tipificar;
						},
						
						id: 'tipificarTel', // Campo obligatorio si se quiere usar desde el contextMenu
						className: 'btn-material-primary-high-emphasis table_toolbar_btnView',
						icon: "mdi-file-send",
						custom:true,				
						insideContextMenu: true, 
						type: 'view',
						action: function (e, dt) {
							tipificar_dialog.rup_dialog("open");
						}				
				  };	
				 
				  customButons.push(tipificarButton);

				  return customButons;
				};
				
				documentos_table.rup_table({
					colReorder: {
						fixedColumnsLeft: 0
					},
					colModel: getColumnsModel(),
					columnDefs:  getColumnsDefs(),
					drawCallback : function( settings ) {//PAra subscribirte a eventos despues de pintar// para cada tr
						Ad74aUtils.desBloquearInterfaz();
				    },
					primaryKey: "idDocBanTel15",
					noEdit: true,
					filter: {
			  	  		id: "documentosBanTel_filter_form",
			  	  		filterToolbar: "documentosBanTel_filter_toolbar",
			  	  		collapsableLayerId: "documentosBanTel_filter_fieldset",
			  	  		showHidden: true
			     	},
			     	select: {
			       		activate: true,
			       		multiSelect:false,
			       		deleteDoubleClick:true
			   		},
			   		createTooltipBody: false,
					buttons: {
						activate: true,
						blackListButtons: ['reportsButton','addButton', 'editButton', 'cloneButton', 'deleteButton'],
						myButtons: getCustomButtons()
					},
					dom: 't<"container-fluid paginationContainer"' +
					  '<"row mx-0"' +
					  '<"col-6 order-3 text-right align-self-center col-sm-5 order-sm-2 col-xl-2 order-xl-1 text-xl-left">' +
					  '<"d-none"p>' +
					  '<"col-12 text-center"i>' +
					  '>' +
					  '>' +
					  'r',
					columnOrderArrows: {
					    showOnlyActive: false,
					    display: 'inline'
					},
					order: [[1, "asc"]]
				});			
				
				documentos_table.on('tableButtonsAfterToolbarInit', function (event, ctx) {//siempre el boton deshabilitado al inicio
					$('#tipificar').prop('disabled', true);
				});
				
				documentos_table.on("click",function(ctx) {
					
					if(documentos_table.rup_table("getSelectedIds").length==0){
						$("#tipificar").prop('disabled', true);
					}else{				
						$("#tipificar").prop('disabled', false);
					}
				});
			}
			
			if($("#idProcedimiento00_observacionesOficio_detail_table").val() == PROCEDIMIENTO_MODIFICACION){				
				iniciarDireccionContacto(expedienteJSON.direcciones, "dirContacto");
				$("label[for='dirContactocp06_detail_table']").addClass('obligatorio');
				$("label[for='dirContactoidprovincia06_detail_table_label']").addClass('obligatorio');
				$("label[for='dirContactoidmunicipio06_detail_table_label']").addClass('obligatorio');
				$("label[for='dirContactoidlocalidad06_detail_table_label']").addClass('obligatorio');
				$("label[for='dirContactolocalidad06_detail_table']").addClass('obligatorio');
				$("label[for='dirContactoidcalle06_detail_table_label']").addClass('obligatorio');
				$("label[for='dirContactocalle06_detail_table']").addClass('obligatorio');
			}
			
			iniciarDireccionNotificacion(expedienteJSON.direccionNotif, "dirNot");
			
}

//Carga los combos
const cargarCombosModificacion = (fromCP) => {
	if( $('#idProcedimientoOficio').val() == '0087004'){
		//Segun entre la primera vez, todos los valores se ponen a vacios y se van cargando con el row
		if(!fromCP){
			$("#cp06_tabSolicitud_detail_table").val("");
			$("#idprovincia06_tabSolicitud_detail_table").val("");
			$("#idmunicipio06_tabSolicitud_detail_table").val("");
			$("#idlocalidad06_tabSolicitud_detail_table").val("");
		}
		
		
		//Cambiamos el valor anterior del codigo postal por el actual y lo seteamos
		$("#cp06_tabSolicitud_detail_table").data("prev", $("#cp06Not_tabSolicitud_detail_table").val());
		
		
		
		
		Ad74aUtils.configCombo($("#idProcedimiento00_observacionesOficio_detail_table"), {
			loadFromSelect: true,
			disabled:true
		});
		//MUNICIPIO
		$("#idmunicipio06_tabSolicitud_detail_table").rup_combo({
			parent: ["idprovincia06_tabSolicitud_detail_table"],			
			source: $.rup.CTX_PATH + 'nora/municipioEnlazado?cp06='+$("#cp06_tabSolicitud_detail_table").val(),
			sourceParam: {label: "descripcion", value:"codMunicipio"},
			rowStriping: true,
			width: 'auto',
			blank: '',
			customClasses: ['select-material'],
			change: function(){
			
			},
			success: function(res){
				console.log("res desde success" + res);
			},
			onLoadSuccess: function(obj){
				console.log();
				if(obj[0].length == 2){
					$("#idmunicipio06_tabSolicitud_detail_table").rup_combo("select", obj[0][1].value);
				}else{
					$("#idmunicipio06_tabSolicitud_detail_table").rup_combo("select", $("#idmunicipio06_tabSolicitud_detail_table").attr("value"));
				}
			}
		});
		
		//LOCALIDAD
		$("#idlocalidad06_tabSolicitud_detail_table").rup_combo({
			parent: ["idprovincia06_tabSolicitud_detail_table", "idmunicipio06_tabSolicitud_detail_table"],			
			source: $.rup.CTX_PATH + 'nora/localidadEnlazado?cp06='+$("#cp06_tabSolicitud_detail_table").val(),
			sourceParam: {label: "descripcion", value:"codLocalidad"},
			rowStriping: true,
			width: 'auto',
			blank: '',
			customClasses: ['select-material'],
			change: function(){
			
			},
			onLoadSuccess: function(obj){
				if(obj[0].length == 2){
					console.log("entro en localidad ==2 --> " + obj[0][1].value);
					$("#idlocalidad06_tabSolicitud_detail_table").rup_combo("select", obj[0][1].value);
				}else{
					$("#idlocalidad06_tabSolicitud_detail_table").rup_combo("select", $("#idmunicipio06_tabSolicitud_detail_table").attr("value"));
				}
			}
		});	
		
		//CALLE
		$("#idcalle06_tabSolicitud_detail_table").rup_combo({
			parent: ["idlocalidad06_tabSolicitud_detail_table"],			
			source: $.rup.CTX_PATH + 'nora/calleEnlazado?cp06='+$("#cp06_tabSolicitud_detail_table").val(),
			sourceParam: {label: "descripcion", value:"idCalle"},
			rowStriping: true,
			width: 'auto',
			blank: '',
			customClasses: ['select-material'],
			change: function(){
				
				if($("#idcalle06_tabSolicitud_detail_table").val() == ''){
					console.log($("#idcalle06_tabSolicitud_detail_table").val());
					$("#calleDesc").show();
					$("#portalDesc").show();
				}else{
					$("#calleDesc").hide();
				}
			},
			onLoadSuccess: function(obj){
				$("#idcalle06_tabSolicitud_detail_table").rup_combo("refresh");
				if(obj[0].length == 2){
					$("#idcalle06_tabSolicitud_detail_table").attr("value", obj[0][1].value);
				}else{
					$("#idcalle06_tabSolicitud_detail_table").attr("value", $("#idcalle06_tabSolicitud_detail_table").attr("value"));
				}
				if($("#idcalle06_tabSolicitud_detail_table").val() == ''){
					
					$("#calleDesc").show();
				}else{
					$("#calleDesc").hide();
				}
			}
		});		
		
		//PORTAL
		$("#idportal06_tabSolicitud_detail_table").rup_combo({
			parent: ["idlocalidad06_tabSolicitud_detail_table","idcalle06_tabSolicitud_detail_table"],			
			source: $.rup.CTX_PATH + 'nora/portalEnlazado',
			sourceParam: {label: "portalCompleto", value:"codPortal"},
			rowStriping: true,
			width: 'auto',
			blank: '',
			customClasses: ['select-material'],
			change: function(){

				if($("#idportal06_tabSolicitud_detail_table").val() == ''){
					$("#portalDesc").show();
				}else{
					$("#portalDesc").hide();
				}
				if($("#cp06_tabSolicitud_detail_table").val()=='' && $("#idportal06_tabSolicitud_detail_table").val() != ''){
					const ajaxData = {
							'url': $.rup.CTX_PATH + 'nora/conseguirCP?portal='+ $("#idportal06_tabSolicitud_detail_table").val() ,
							'type': 'GET',
							'contentType': 'application/json',
							'dataType': 'json',
							success: function (res) {
								$("#cp06_tabSolicitud_detail_table").val(res);
							},
							error: function (error) {
								$("#iniciosOficio_feedback").rup_feedback('set', error.responseText, "error");	
							}
						};
						
					$.rup_ajax(ajaxData);
				}
			},
			onLoadSuccess: function(obj){
				$("#idportal06_tabSolicitud_detail_table").rup_combo("refresh");
				if(obj[0].length == 2){
					$("#idportal06_tabSolicitud_detail_table").attr("value", obj[0][1].value);
				}else {
					$("#idportal06_tabSolicitud_detail_table").attr("value", $("#idportal06_tabSolicitud_detail_table").attr("value"));
				}
				if($("#idportal06_tabSolicitud_detail_table").val() == ''){
					$("#portalDesc").show();
				}else{
					$("#portalDesc").hide();
				}
			}
		});	
	}
}
const cargarCombosDatosDomicilioNora = (fromCP) => {
	
		//Segun entre la primera vez, todos los valores se ponen a vacios y se van cargando con el row
		if(!fromCP){
			$("#cp06Not_tabSolicitud_detail_table").val("");
			$("#idprovincia06Not_tabSolicitud_detail_table").val("");
			$("#idmunicipio06Not_tabSolicitud_detail_table").val("");
			$("#idlocalidad06Not_tabSolicitud_detail_table").val("");
		}
		
		
		//Cambiamos el valor anterior del codigo postal por el actual y lo seteamos
		$("#cp06Not_tabSolicitud_detail_table").data("prev", $("#cp06Not_tabSolicitud_detail_table").val());
		
		
		//Combos de dirección
		//PROVINCIA
//		$("#dirNotidprovincia06_detail_table").rup_combo({
//			source:  $.rup.CTX_PATH + 'nora/provincias',
//			sourceParam: {label: "descProvincia", value:"codProvincia"},
//			rowStriping: true,
//			width: 'auto',
//			blank: '',
//			customClasses: ['select-material'],
//			change: function(){				
//				//refrescarCombo("idmunicipio06");
//			},
//			onLoadSuccess: function(obj){
//				if(obj[0].length == 2){
//					$("#dirNotidprovincia06_detail_table").rup_combo("select", obj[0][1].value);
//				}else{
//					$("#dirNotidprovincia06_detail_table").rup_combo("select", $("#dirNotidprovincia06_detail_table").attr("value"));
//				}
//				
//			}
//		});
		
		Ad74aUtils.configCombo($("#idProcedimiento00_observacionesOficio_detail_table"), {
			loadFromSelect: true,
			disabled:true
		});
		
		//MUNICIPIO
		$("#idmunicipio06Not_tabSolicitud_detail_table").rup_combo({
			parent: ["idprovincia06Not_tabSolicitud_detail_table"],			
			source: $.rup.CTX_PATH + 'nora/municipioEnlazado?cp06='+$("#cp06Not_tabSolicitud_detail_table").val(),
			sourceParam: {label: "descripcion", value:"codMunicipio"},
			rowStriping: true,
			width: 'auto',
			blank: '',
			customClasses: ['select-material'],
			change: function(){
				//refrescarCombo("idlocalidad06");
			},
			success: function(res){
				console.log("res desde success" + res);
			},
			onLoadSuccess: function(obj){
				console.log();
				if(obj[0].length == 2){
					$("#idmunicipio06Not_tabSolicitud_detail_table").rup_combo("select", obj[0][1].value);
				}else{
					$("#idmunicipio06Not_tabSolicitud_detail_table").rup_combo("select", $("#idmunicipio06Not_tabSolicitud_detail_table").attr("value"));
				}
			}
		});
		
		//LOCALIDAD
		$("#idlocalidad06Not_tabSolicitud_detail_table").rup_combo({
			parent: ["idprovincia06Not_tabSolicitud_detail_table", "idmunicipio06Not_tabSolicitud_detail_table"],			
			source: $.rup.CTX_PATH + 'nora/localidadEnlazado?cp06='+$("#cp06Not_tabSolicitud_detail_table").val(),
			sourceParam: {label: "descripcion", value:"codLocalidad"},
			rowStriping: true,
			width: 'auto',
			blank: '',
			customClasses: ['select-material'],
			change: function(){
				//refrescarCombo("idcalle06");
			},
			onLoadSuccess: function(obj){
				if(obj[0].length == 2){
					console.log("entro en localidad ==2 --> " + obj[0][1].value);
					$("#idlocalidad06Not_tabSolicitud_detail_table").rup_combo("select", obj[0][1].value);
				}else{
					$("#idlocalidad06Not_tabSolicitud_detail_table").rup_combo("select", $("#idmunicipio06Not_tabSolicitud_detail_table").attr("value"));
				}
			}
		});	
		
		//CALLE
		$("#idcalle06Not_tabSolicitud_detail_table").rup_combo({
			parent: ["idlocalidad06Not_tabSolicitud_detail_table"],			
			source: $.rup.CTX_PATH + 'nora/calleEnlazado?cp06='+$("#cp06Not_tabSolicitud_detail_table").val(),
			sourceParam: {label: "descripcion", value:"idCalle"},
			rowStriping: true,
			width: 'auto',
			blank: '',
			customClasses: ['select-material'],
			change: function(){
				//refrescarCombo("idcalle06");
				if($("#idcalle06Not_tabSolicitud_detail_table").val() == ''){
					$("#calleDescNot").show();
					$("#portalDescNot").show();
				}else{
					$("#calleDescNot").hide();
				}
			},
			onLoadSuccess: function(obj){
				$("#idcalle06Not_tabSolicitud_detail_table").rup_combo("refresh");
				if(obj[0].length == 2){
					$("#idcalle06Not_tabSolicitud_detail_table").attr("value", obj[0][1].value);
				}else{
					$("#idcalle06Not_tabSolicitud_detail_table").attr("value", $("#idcalle06Not_tabSolicitud_detail_table").attr("value"));
				}
				if($("#idcalle06Not_tabSolicitud_detail_table").val() == ''){
					$("#calleDescNot").show();
				}else{
					$("#calleDescNot").hide();
				}
			}
		});		
		
		//PORTAL
		$("#idportal06Not_tabSolicitud_detail_table").rup_combo({
			parent: ["idlocalidad06Not_tabSolicitud_detail_table","idcalle06Not_tabSolicitud_detail_table"],			
			source: $.rup.CTX_PATH + 'nora/portalEnlazado',
			sourceParam: {label: "portalCompleto", value:"codPortal"},
			rowStriping: true,
			width: 'auto',
			blank: '',
			customClasses: ['select-material'],
			change: function(){
				//refrescarCombo("idcalle06");
				if($("#idportal06Not_tabSolicitud_detail_table").val() == ''){
					$("#portalDescNot").show();
				}else{
					$("#portalDescNot").hide();
				}
				if($("#cp06Not_tabSolicitud_detail_table").val()=='' && $("#idportal06Not_tabSolicitud_detail_table").val() != ''){
					const ajaxData = {
							'url': $.rup.CTX_PATH + 'nora/conseguirCP?portal='+ $("#idportal06Not_tabSolicitud_detail_table").val() ,
							'type': 'GET',
							'contentType': 'application/json',
							'dataType': 'json',
							success: function (res) {
								$("#cp06Not_tabSolicitud_detail_table").val(res);
							},
							error: function (error) {
								$("#iniciosOficio_feedback").rup_feedback('set', error.responseText, "error");	
							}
						};
						
					$.rup_ajax(ajaxData);
				}
			},
			onLoadSuccess: function(obj){
				$("#idportal06Not_tabSolicitud_detail_table").rup_combo("refresh");
				if(obj[0].length == 2){
					$("#idportal06Not_tabSolicitud_detail_table").attr("value", obj[0][1].value);
				}else {
					$("#idportal06Not_tabSolicitud_detail_table").attr("value", $("#idportal06Not_tabSolicitud_detail_table").attr("value"));
				}
				if($("#idportal06Not_tabSolicitud_detail_table").val() == ''){
					$("#portalDescNot").show();
				}else{
					$("#portalDescNot").hide();
				}
			}
		});	
	
};
const inicioOficio = (oficio) => {
	 
	let existsOficio = false;
	for( const o of tiposOficio){
		if(o.procedure == oficio) {
			existsOficio = true;
		}
	}
	
	if(!existsOficio){
		Ad74aUtils.openConfirmDialog(
			'dialogConfirmOficios', 
			$.rup.i18n.app.dialog.title.solicitudOficio, 
			`<i class="mdi mdi-information-outline verde" style="margin-right: 1rem;font-weight: 700;font-size: 2rem;vertical-align: middle; color: #666666"></i>
			El oficio que intenta iniciar no está definido`,  
			[
	        	{
	                text: $.rup.i18n.app.botonera.cerrar,
	                id: 'btnCerrarErrorOficio',
	                click: function () { 
	                    $('#dialogConfirmOficios').rup_dialog('close'); 
	                },
	                class: "btn-material-primary-low-secondary-emphasis"
	                
	            },
	        ],
	        'custom_small_dialog rup-message rup-message-alert'
	        
		);	
		
		// Dialog de error y success
		const divDialogTitle = $("div[aria-describedby='dialogConfirmOficios'] .ui-dialog-titlebar");
		divDialogTitle.removeClass("app-primary-color");		
		$("#dialogConfirmOficios_close").css("color", "#666666");
		$("#btnCerrarErrorOficio").removeClass("btn-material-primary-low-emphasis");
		

		return false;
	}
	
	currentOficio = oficio;
	$('#dialogIniciosOficio').rup_dialog("open");
	
	
	
}

function FN_controlCanalNot(){
	
	if($("#A_canalNot00_tabSolicitud_detail_table").is(':checked')){
		$("#tlfnNotGrupo").show();
		$("#emailNotGrupo").show();
	}if($("#E_canalNot00_tabSolicitud_detail_table").is(':checked')){
		$("#emailNotGrupo").show();
		$("#tlfnNotGrupo").hide();
	}if($("#S_canalNot00_tabSolicitud_detail_table").is(':checked')){
		$("#tlfnNotGrupo").show();
		$("#emailNotGrupo").hide();
	}

}

const iniciarOficio = () => {
	var properties={
			feedback:$("#iniciosOficio_feedback"),
			liveCheckingErrors: false,
			showFieldErrorAsDefault: true,
			showErrorsInFeedback: true,
			showFieldErrorsInFeedback: true,
			rules:{
				  "solicitantes.identificador01":{validarDNIIdentificador:true},
				  "identificadorCon00":{validarIdentificador:true},
				  "fBaja00":{required:true,date:true},
				  "idiomaNot00":{required:true},
				  "idTipoNot00":{required:true},
				  "canalNot00":{required:true},
				  "perfiles.pisoTutelado07" : {checkPisosTutelados: true},
				  "direcciones.cp06":{required:true},
				  "direcciones.idProvincia06_label":{required:true},
			      "direcciones.idMunicipio06_label":{required:true},
				  "direcciones.localidad06":{ 
					  required:function(){
						  return $("[name='direcciones.idLocalidad06_label']").val()=='';
			      },       
				  "direcciones.idLocalidad06_label":{ 
					  required:function(){
						  return $("[name='direcciones.localidad06']").val()=='';
					  }
			      },     
				  "direcciones.calle06":{ 
					  required:function(){
						  return $("[name='direcciones.idCalle06_label']").val()=='';
					  }
				  },   
				  "direcciones.idCalle06_label":{
					  required:function(){
						  return $("[name='direcciones.calle06']").val()=='';
					  }
				  },
			      "direccionNotif.cp06":{required:true},
			      "direccionNotif.idProvincia06_label":{
			    	  required:function(){
			    		  return $("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked');
			    	  }
			      },
			      "direccionNotif.idMunicipio06_label":{
			    	  required:function(){
			    		  return $("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked');
			    	  }
			      },
			      "direccionNotif.localidad06":{ 
			    	  required:function(){
			    		  return $("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked') && $("[name='direccionNotif.idLocalidad06_label']").val()=='';
			    	  }
			      },       
				  "direccionNotif.idLocalidad06_label":{
			    	  required:function(){
			    		  return $("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked') && $("[name='direccionNotif.localidad06']").val()=='';
			    	  }
			      },
			      "direccionNotif.calle06":{ 
			    	  required:function(){
			    		  return $("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked') && $("[name='direccionNotif.idCalle06_label']").val()=='';
			    	  }
			      },   
				  "direccionNotif.idCalle06_label":{
					  required:function(){
						  return $("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked') && $("[name='direccionNotif.calle06']").val()=='';
						  }
			      }
			}
		}
	};
	 
	 
	$("#inicioOficio_form").rup_validate(properties);
	if($("#inicioOficio_form").valid()){
		if(validarDocLiq()){
			Ad74aUtils.bloquearInterfaz();
			let url = $.rup.CTX_PATH + "inicioOficio/iniciarOficio";
			let idaviso = new URLSearchParams(window.location.search).get('avisos');
			
			if (idaviso) {
			    url += '?idaviso=' + idaviso;
			}else if ($("#idProcedimiento00_observacionesOficio_detail_table").val() == '0087007') {
			    url += '?idLiquidaciones=' + $("#idLiquidacion00").val();
			} 
			let data = {};
			data.expediente = window.form2object($("#inicioOficio_form")[0]);	
			if(data.expediente.liquidaciones != undefined){
			data.expediente.liquidaciones.importe00=0;
			}			
			data = JSON.stringify(data);
					
			const ajaxData = {
					'url': url,
					'type': 'POST',
					'data': data,
					'contentType': 'application/json',
					'dataType': 'json',
					success: function (res) {
						$('#dialogIniciosOficio').rup_dialog('close');
						
						// TODO: Abrir una nueva pestaña al expediente recien creado
						//window.location.href = $.rup.CTX_PATH + 'expedientes/detail/' + res.idExpediente00;
						window.location.href = $.rup.CTX_PATH + 'bandejas/cuadromando';
					},
					error: function (error) {
						Ad74aUtils.desBloquearInterfaz();
						$("#iniciosOficio_feedback").rup_feedback('set', error.responseText, "error");	
					}
				};
				
			$.rup_ajax(ajaxData);
		}else{
			//mostrar error validacion documento liquidacion
			$("#iniciosOficio_feedback").rup_feedback('set', $.rup.i18n.app.errores.docLiq, "error");	
			
		}
	}
		
		
}

function obtenerParametroGET(nombre) {
    var url = window.location.search.substring(1); // obtiene la cadena de la URL después del "?"
    var parametros = url.split('&');

    for (var i = 0; i < parametros.length; i++) {
        var parametro = parametros[i].split('=');
        if (parametro[0] == nombre) {
            return decodeURIComponent(parametro[1]);
        }
    }
    return null; // devuelve null si el parámetro no se encuentra
}


/**
 * Inicializa un upload integrado con PIF
 */
function iniciarUpload(){
	$("#subirDocOficio_feedback").rup_feedback(
			{
				type: "ok",
				block: false,
				gotoTop: false
			}
		);
	const urlAportar = 'addDocumentoOficio'; 

	UploadFile.init("documento", {
        selectButton: {                    
            "text": $.rup.i18n.app.botonera.seleccionar,
            "icon": "mdi mdi-plus",
            "class": "btn-material-primary-high-emphasis",
        },
        uploadButton: {
            "text": $.rup.i18n.app.botonera.aportar,
            "icon": "mdi mdi-upload",
            "class": "btn-material-primary-high-emphasis",
        },
        
        "submitInForm": false,
        "url": urlAportar,
        data: () => {
        	return { 
        		"tipificar": $("#idTipoDoc_tipificar_oficios").val(),
        		"nombreTipificar" : $('#idTipoDoc_tipificar_oficios option:selected').text()
        	}
        },
        start : function (data) {
        	Ad74aUtils.cerrarFeedbacks();
			Ad74aUtils.bloquearInterfaz();
		},
		done: function (data) {
			$("#subirDocOficio_feedback").rup_feedback('option', "delay", 3000);
			$("#subirDocOficio_feedback").rup_feedback('set', $.rup.i18n.app.feedback.documentoAportadoOk, "ok");
			UploadFile.reset("documento");			
			Ad74aUtils.desBloquearInterfaz();
			$('#documento_table').rup_table('reload');
		},
		fail: function (data) {
			console.log(data);
			$("#subirDocOficio_feedback").rup_feedback('option', "delay", null);
			$("#subirDocOficio_feedback").rup_feedback('set', data.error, "error");
			UploadFile.reset("documento");
			Ad74aUtils.desBloquearInterfaz();
		},	
    });
	

    
 
}


const tableColModelDocumentos = [
	{
        name: 'tipoDocumentoDescEs',
        index: 'tipoDocumentoDescEs',
        editable: true,
        hidden: false,
        orderable: false
    },
    {
        name: 'nombreDocumento',
        index: 'nombreDocumento',
        editable: true,
        hidden: false,
        orderable: false
    },
    {
        name: 'oidDocumento',
        index: 'oidDocumento',
        editable: true,
        hidden: false,
        orderable: false
    }
]
let columnDefsDocumentos = [
	{
		"targets": 2, 
	    "render": function ( data, type, row, meta ) {
	             return "<a href='#'><i class='mdi mdi-trash-can-outline' style='margin-right:5px;'></i></a>";               
		},
	}
];

function cargarTablaDocumentos(){
	 $('#documento_table').rup_table({
	        colModel: tableColModelDocumentos,
	        columnDefs:[
	        	{
	        		"targets":0,
	        		"render": function (data,type,row,meta){
	        			return row.tipoDocumentoDescEs.replace(/"/g, '');
	        		}
	        	},
	        	{
	        		"targets": 2, 
	        	    "render": function ( data, type, row, meta ) {
	        			if(row.vieneAvisos){
	        				return "<a href='javascript:eliminarDocumentoAviso()'><i class='mdi mdi-trash-can-outline' style='margin-right:5px;'></i></a>";
	        			}else{
	        	             return "<a href='javascript:eliminarDocumento("+row.idDocumento+")'><i class='mdi mdi-trash-can-outline' style='margin-right:5px;'></i></a>";          
	        			}     
	        		},
	        	},
	        	{
	        		"targets": 1, 
	        	    "render": function ( data, type, row, meta ) {
	        			var comillaSimple = "'";
	        	        return `<a href='javascript:visualizarDocumento("${row.nombreDocumento}","${row.vieneAvisos}","${row.oidDocumento}","${row.rutaPif}")'>${row.nombreDocumento}</a>`;               
	        		},
	        	},
	        ],
			filter: "noFilter",
			createTooltipBody: false,// No muestra el tooltip automático de las columnas de la tabla
			primaryKey: "oidDocumento",
			dom: 't<"container-fluid paginationContainer"' +
			  '<"row mx-0"' +
			  '<"col-6 order-3 text-right align-self-center col-sm-5 order-sm-2 col-xl-2 order-xl-1 text-xl-left">' +
			  '<"d-none"p>' +
			  '<"col-12 text-center"i>' +
			  '>' +
			  '>' +
			  'r',
	        order: [[ 1, 'asc' ]]
	 });
}

function eliminarDocumentoAviso(idDocumento){
  	alert($.rup.i18n.app.errores.eliminarDocAviso);
}
function eliminarDocumento(idDocumento){
	
    $.rup_ajax({
          url: $.rup.CTX_PATH +"inicioOficio/eliminarDocumento/"+idDocumento,
          type: "DELETE",            
          dataType: 'json',
          contentType: 'application/json',
          success: function (res){
                $('#documento_table').rup_table('reload');
				$("#subirDocOficio_feedback").rup_feedback('option', "delay", 3000);
				$("#subirDocOficio_feedback").rup_feedback('set', $.rup.i18n.app.inicioOficio.documentoBorrado, "ok");
		 },
          error: function(error){
				$("#subirDocOficio_feedback").rup_feedback('option', "delay", null);
				$("#subirDocOficio_feedback").rup_feedback('set', error.responseJSON || error.responseText, "ok");
          }
    });
}

const iniciarDireccionContacto = (direccion, prefix) => {
	
	// Mostrar/ocultar los datos alternativos inicialmente
	if($("#"+prefix+"idlocalidad06_detail_table").val() == ''){						
		$("#"+prefix+"localidadDesc").show();
		$("#"+prefix+"calleDesc").show();
		$("#"+prefix+"portalDesc").show();
	}else{
		$("#"+prefix+"localidadDesc").hide();
	}
	
	if($("#"+prefix+"idcalle06_detail_table").val() == ''){						
		$("#"+prefix+"calleDesc").show();
		$("#"+prefix+"portalDesc").show();
	}else{
		$("#"+prefix+"calleDesc").hide();
	}
	
	if($("#"+prefix+"idportal06_detail_table").val() == ''){
		$("#"+prefix+"portalDesc").show();
	}else{
		$("#"+prefix+"portalDesc").hide();
	}
	
	// Iniciar el componente dirección de contacto
	console.log("Iniciar el componente");
	console.log(direccion);		
	console.log(prefix);
	initDirComponentAutocomplete({
		"prefix": prefix,
		"direccion": direccion, 
		"pisoTutelado": true,
		"callbacks": {
			"general": {
				"success": () => {											
					
					$("#idPiso32_tabSolicitud_detail_table").rup_combo({
						source:  $.rup.CTX_PATH + 'combo/pisosTutelados?idProvincia06=' + direccion.idProvincia06 + '&idMunicipio06=' + direccion.idMunicipio06,
						sourceParam: {label: "denominacion32", value:"idPiso32"},
						loadFromSelect:false,
						width: 'auto',
				        ordered: false,
				        blank: '',
						customClasses: ['select-material'],
						onLoadSuccess: function(obj){
							if(obj[0].options.length > 1){
								$("#idPiso32_tabSolicitud_detail_table").rup_combo('refresh');
							}	
							$("#idPiso32_tabSolicitud_detail_table").change(function(){FN_verificarDireccionPisoTutelado()});
						},
						rowStriping: true
					});
				}
			},
			"municipio": {
				"change": () => {
					FNRefrescarPisoTutelado({
							"prefix": prefix});	
				},
			},
			"localidad": {
				"change": () => {
						// TODO: refrescar pisostutelados	
//					FNRefrescarPisoTutelado({
//						"prefix": prefix});	
					FN_verificarDireccionPisoTutelado();
				},
			},
			"calle": {
				"change": () => {						
					FNRefrescarPisoTutelado({
						"prefix": prefix});	
					FN_verificarDireccionPisoTutelado();
					
				},
			},
			"portal": {
				"change": () => {						
					FNRefrescarPisoTutelado({
						"prefix": prefix});	
					FN_verificarDireccionPisoTutelado();
				},
					}
				}
	});
}

const FNRefrescarPisoTutelado=(settings)=>{
	if($("#"+settings.prefix+"idprovincia06_detail_table").rup_autocomplete('getRupValue')!==''
		&& $("#"+settings.prefix+"idmunicipio06_detail_table").rup_autocomplete('getRupValue')!==''){
		const sourcePath = $.rup.CTX_PATH + 'combo/pisosTutelados?idProvincia06=' + 
		$("#"+settings.prefix+"idprovincia06_detail_table").rup_autocomplete('getRupValue') + 
		'&idMunicipio06=' + $("#"+settings.prefix+"idmunicipio06_detail_table").rup_autocomplete('getRupValue');
		$("#idPiso32_tabSolicitud_detail_table").rup_combo("setSource",sourcePath);
	}
}

const iniciarDireccionNotificacion = (direccion, prefix) => {
	
	// Mostrar/ocultar los datos alternativos inicialmente
	if($("#"+prefix+"idlocalidad06_detail_table").val() == ''){						
		$("#"+prefix+"localidadDesc").show();
		$("#"+prefix+"calleDesc").show();
		$("#"+prefix+"portalDesc").show();
	}else{
		$("#"+prefix+"localidadDesc").hide();
	}
	
	if($("#"+prefix+"idcalle06_detail_table").val() == ''){						
		$("#"+prefix+"calleDesc").show();
		$("#"+prefix+"portalDesc").show();
	}else{
		$("#"+prefix+"calleDesc").hide();
	}
	
	if($("#"+prefix+"idportal06_detail_table").val() == ''){
		$("#"+prefix+"portalDesc").show();
	}else{
		$("#"+prefix+"portalDesc").hide();
	}
	
	// Iniciar el componente dirección de contacto
//	console.log("Iniciar el componente");
//	console.log(direccion);
	initDirComponentAutocomplete({
		"prefix": prefix,
		"direccion": direccion, 
		"pisoTutelado": false,
		"provinciasNoCAV":true,
		"callbacks": {
			"general": {
				"success": () => {}
			},
//			"localidad": {
//				"change": () => {
//					if($("#"+prefix+"idlocalidad06_detail_table").rup_autocomplete("getRupValue") == ''
//						|| $("#"+prefix+"idlocalidad06_detail_table_label").val() == ''){						
//						$("#"+prefix+"localidadDesc").show();
//					}else{
//						$("#"+prefix+"localidadDesc").hide();
//					}
//				},
//			},
//			"calle": {
//				"change": () => {
//					if($("#"+prefix+"idcalle06_detail_table").rup_autocomplete("getRupValue") == ''
//						|| $("#"+prefix+"idcalle06_detail_table_label").val() == ''){						
//						$("#"+prefix+"calleDesc").show();					
//						$("#"+prefix+"portalDesc").show();
//						$("#"+prefix+"calleNora").hide();
//						$("#"+prefix+"portaNora").hide();
//					}else{
//						$("#"+prefix+"calleDesc").hide();
//						$("#"+prefix+"portalDesc").hide();
//						$("#"+prefix+"calleNora").show();
//						$("#"+prefix+"portaNora").hide();
//					}
//				},
//			},
//			"portal": {
//				"change": () => {	
//					if($("#"+prefix+"idportal06_detail_table").rup_autocomplete("getRupValue") == ''
//						|| $("#"+prefix+"idportal06_detail_table_label").val() == ''){						
//						$("#"+prefix+"portalDesc").show();
//					}else{
//						$("#"+prefix+"portalDesc").hide();
//					}
//				},
//			}
					}
	});
}

const FN_obtenerDireccionPisoTutelado = (idPiso32) => {
	let url =  $.rup.CTX_PATH + 'bandejapapel0/obtenerDireccionPisoTutelado';
	let calle = $("#dirContactoidcalle06_detail_table").val();
	let municipio = $("#dirContactoidmunicipio06_detail_table").val();
	let provincia = $("#dirContactoidprovincia06_detail_table").val();
	let cp = $("#dirContactocp06_detail_table").val();
	let data = {};
	data.idPiso32 = idPiso32;
	data.calle = calle;
	data.municipio = municipio;
	data.provincia = provincia;
	data.cp = cp;
	$.rup_ajax({
		url: url,
		type: 'POST',
		data: JSON.stringify(data),
		contentType: 'application/json',
		dataType: 'json',
		success: function (res) {
			
			$('#resultadoPisoTutelado').html("Las direcciones no coinciden --> " + res);
			$("#resultadoPisoTutelado").css("color", "red");
			$("#recuadroResultadoPisoTutelado").removeClass("ok");
			
			$("#recuadroResultadoPisoTutelado").addClass("aviso_interoperabilidad nook");
			$("#recuadroResultadoPisoTutelado").css("border-radius: 3px");
		},
		error: function (error) {
			console.log("Error");
		}	
	});
}

const FN_verificarDireccionPisoTutelado = () => {
	let url =  $.rup.CTX_PATH + 'bandejapapel0/verificarPisoTutelado';
	let letra = $("#dirContactoletra06_detail_table").val();
	let calle = $("#dirContactoidcalle06_detail_table").val();
	let portal = $("#dirContactoidportal06_detail_table").val(); 
	let piso = $("#dirContactopiso06_detail_table").val();  
	let idPiso32 = $('#idPiso32_tabSolicitud_detail_table').val();
	if( calle != '' && portal != ''  && (idPiso32 != 'true'&& idPiso32 != '') ){
		 let data = {};
		 data.letra = letra;
		 data.calle = calle;
		 data.portal = portal;
		 data.piso = piso;
		 data.idPiso32 = idPiso32;
		 $.rup_ajax({
				url: url,
				type: 'POST',
				data: JSON.stringify(data),
				contentType: 'application/json',
				dataType: 'json',
				success: function (res) {
					if(res == true){
						$('#resultadoPisoTutelado').html("Las direcciones coinciden");
						$("#resultadoPisoTutelado").css("color", "green");
						$( "#recuadroResultadoPisoTutelado" ).removeClass("nook");
						$("#recuadroResultadoPisoTutelado").addClass("aviso_interoperabilidad ok");
						$("#recuadroResultadoPisoTutelado").css("border-radius: 3px");
					}else{
						FN_obtenerDireccionPisoTutelado(idPiso32);
					}
				},
				error: function (error) {
					console.log("Error");
				}	
			});
	}else{
		if(idPiso32 == 'true' || idPiso32 == ''){
			$('#resultadoPisoTutelado').html("Seleccione un piso tutelado valido");
			$("#resultadoPisoTutelado").css("color", "red");
			$( "#recuadroResultadoPisoTutelado" ).removeClass("ok");
			$("#recuadroResultadoPisoTutelado").addClass("aviso_interoperabilidad nook");
			$("#recuadroResultadoPisoTutelado").css("border-radius: 3px");
		}else{
			FN_obtenerDireccionPisoTutelado(idPiso32);
		}
	}
	
}

function FN_controlRadioPisoTutelado(){
	console.log("FN_controlRadioPisoTutelado");
	if($("#SI_pisoTutelado07_tabSolicitud_detail_table").is(":checked")){
		
		$("#pisosTuteladosGrupo").show();
		$("#resultadoPisoTutelado").show();
		
		
	}else{
		$("#pisosTuteladosGrupo").hide();
		
		$("#resultadoPisoTutelado").hide();
		
	}
}
function visualizarDocumento(url,vieneAvisos,oidDocumento,rutaPif){
	let urlTotal = "";
	console.log(typeof vieneAvisos);
	console.log(vieneAvisos)
	if(vieneAvisos == 'true'){
		urlTotal = $.rup.CTX_PATH+"inicioOficio/downloadDocumento?nombreDoc="+url+"&enlaceCodigo="+oidDocumento+"&esOid="+vieneAvisos;
	}else{
		urlTotal = $.rup.CTX_PATH+"inicioOficio/downloadDocumento?nombreDoc="+url+"&enlaceCodigo="+rutaPif+"&esOid="+vieneAvisos;
	}
	
	window.open($.rup_utils.setNoPortalParam(encodeURI(urlTotal)));	
}

const tableColModelLiquidaciones = [
	{
        name: 'referenciaLiq00',
        index: 'referenciaLiq00',
        editable: false,
        hidden: false,
        orderable: false
    },
    {
        name: 'concepto00',
        index: 'concepto00',
        editable: false,
        hidden: false,
        orderable: false
    },
    {
        name: 'importe00',
        index: 'importe00',
        editable: false,
        hidden: false,
        orderable: false
    },
    {
        name: 'fEmision00',
        index: 'fEmision00',
        editable: false,
        hidden: false,
        orderable: false
    },
    {
        name: 'fLimitePago00',
        index: 'fLimitePago00',
        editable: false,
        hidden: false,
        orderable: false
    }
];
const misbotones = [
	];
const btnSeleccionar ={
		text: function () {
			return $.rup.i18n.app.botonera.seleccionar;
		},
		id: 'btnSeleccionar',
		className: 'btn-material-primary-high-emphasis table_toolbar_btnView',
		icon: "mdi mdi-plus",
		displayRegex: /^\d+$/, // Se muestra siempre
										// que sea un numero
										// mayor a 0
		insideContextMenu: true, // Independientemente de
									// este valor, sera 'false'
									// si no tiene un id
									// definido
		type: 'view',
		action : function(e, dt, node, config) {
			var data=$("#liquidaciones").rup_table("getSelectedRows");
			if(data!=null){
				$('#referenciaLiq00_liquidaciones_dialog_table').val(data.referenciaLiq00);
				$('#concepto00_liquidaciones_dialog_table').val(data.concepto00);
				$('#importe00_liquidaciones_dialog_table').val(data.importe00);
				$('#fEmision00_liquidaciones_dialog_table').val(data.fEmision00);
				$('#fLimitePago00_liquidaciones_dialog_table').val(data.fLimitePago00);
				$("#idLiquidacion00").val(data.idLiquidacion00);
				
				//enrutar el enlace y mostrar
				$("#verPago").attr("href",url_pago+data.idLiquidacion00);
				$("#layerEnlaceverPago").show();
				
				$("#buscarLiquidacionBtn").show();
				$("#verPagoBtn").show();
				$('#tablaLiq').hide();
			}else{
				alert("sin datos");
				$('#referenciaLiq00_liquidaciones_dialog_table').val("");
				$('#concepto00_liquidaciones_dialog_table').val("");
				$('#importe00_liquidaciones_dialog_table').val("");
				$('#fEmision00_liquidaciones_dialog_table').val("");
				$('#fLimitePago00_liquidaciones_dialog_table').val("");
				
				//desenrutar el enlace y ocultar
				$("#verPago").attr("href",url_pago);
				$("#layerEnlaceverPago").hide();
				
				$("#buscarLiquidacionBtn").show();
				$("#verPagoBtn").hide();
				$('#tablaLiq').show();
			}
		}
	};
function cargarTablaLiquidaciones(){
	misbotones.push(btnSeleccionar);
	$("#liquidaciones").attr("data-url-base", $.rup.CTX_PATH  + "inicioOficio/liquidaciones");
	
	$('#liquidaciones').rup_table({
	        colModel: tableColModelLiquidaciones,
	        columnDefs: [
	            { targets: '_all', visible: true }
	        ],select:{
	            // Propiedades de configuraciÃ³n del plugin select
	        	//accion:selectRow
	        },
	       // url:$.rup.CTX_PATH  + "inicioOficio/liquidacionesSolicitante/"+dniSolicitante,
			filter: "noFilter",
			createTooltipBody: false,// No muestra el tooltip automático de las columnas de la tabla
			primaryKey: "referenciaLiq00",
			buttons: {
				activate: true,
				contextMenu: false,
				blackListButtons: ['addButton', 'editButton', 'cloneButton', 'deleteButton', 'copyButton', 'pdfButton', 'odsButton', 'csvButton', 'reportsButton'],
				myButtons:misbotones
			},
			/*dom: 't<"container-fluid paginationContainer"' +
			  '<"row mx-0"' +
			  '<"col-6 order-3 text-right align-self-center col-sm-5 order-sm-2 col-xl-2 order-xl-1 text-xl-left">' +
			  '<"d-none"p>' +
			  '<"col-12 text-center"i>' +
			  '>' +
			  '>' +
			  'r',*/
	        order: [[ 1, 'asc' ]]
	 });
	$('#tablaLiq').hide();
	
}
const buscarSolicitante = function(){
	Ad74aUtils.cerrarFeedbacks();

	  $("#buscarSolicitanteBtn").blur(); 
	 
	  // Validar tipo y dni
	  const dniValid = $('#dniSolicitante_informes_dialog_table').valid(); 
	  const tipoValid = $('#tipoIden00_informes_dialog_table').valid();
	 
//	  if($('#dniSolicitante_informes_dialog_table').val().length==9){}
	  if(tipoValid && dniValid){
		  $.rup_ajax({
              url: $.rup.CTX_PATH +"inicioOficio/obtenerDatosBeneficiario/"+ $("#dniSolicitante_informes_dialog_table").val(),
              type: "POST",            
              dataType: 'json',
              contentType: 'application/json',
				beforeSend: function() {
					Ad74aUtils.bloquearInterfaz();
                },
                complete: function() {
                	//Sólo se desbloquea al fallar para prevenir doble click	                	
                },
              success: function (data){
				
				$('#idSolicitante01_informes_dialog_table').val('');
				$('#nombre02_informes_dialog_table').val('');
				$('#apellido102_informes_dialog_table').val('');
				$('#apellido202_informes_dialog_table').val('');
				if(data.idSolicitante01 != null && data.fBaja01 == null){
					$('#nombre01_informes_dialog_table').val(data.nombre01);
					$('#apellido101_informes_dialog_table').val(data.apellido101);
					$('#apellido201_informes_dialog_table').val(data.apellido201);
					$('#idSolicitante01_informes_dialog_table').val(data.idSolicitante01);
					$('.datosNuevoBeneficiario').hide();
					$('.datosBeneficiario').show();
					$("#buscarSolicitanteBtn i").fadeOut();
					$("#buscarSolicitanteBtn i").removeClass("mdi-magnify");
					$("#buscarSolicitanteBtn i").addClass("mdi-check verde");
					$("#buscarSolicitanteBtn i").fadeIn();
					
					setTimeout(() => {
						$("#buscarSolicitanteBtn i").fadeOut();
						$("#buscarSolicitanteBtn i").addClass("mdi-magnify");
						$("#buscarSolicitanteBtn i").removeClass("mdi-check verde");
						$("#buscarSolicitanteBtn i").fadeIn();
					}, 2000);
					$('#iniciarOficio_detail_button_save').prop("disabled",false);
					if($("#idProcedimiento00_observacionesOficio_detail_table").val() == '0087007'){
						limpiarLiquidaciones();
						obtenerLiquidacionesSolicitante();
					}
					
					// Mostrar datos de notificación
					/*if(data.ultimoExpediente != null){							
						//$("[name='idiomaNot00'][value='"+data.ultimoExpediente.idiomaNot00+"']").prop('checked',true);
						//$("[name='idTipoNot00'][value='"+data.ultimoExpediente.idTipoNot00+"']").prop('checked',true);
						//$("[name='canalNot00'][value='"+data.ultimoExpediente.canalNot00+"']").prop('checked',true);
						
						//$("#tfnoNot00_tabSolicitud_detail_table").val(data.ultimoExpediente.tfnoNot00);
						$("#emailNot00_tabSolicitud_detail_table").val(data.ultimoExpediente.emailNot00);
					}else {*/
						
						$("[name='idiomaNot00'][value='"+  ((data.idiomaServicio01 == TIPO_IDIOMASERVICIO01_ES )?  TIPO_CASTELLANO :  TIPO_EUSKARA)    +"']").prop('checked',true);
						$("[name='idTipoNot00'][value='"+  TIPO_NOTIFICACION_POSTAL +"']").prop('checked',true);
						$("[name='canalNot00'][value='" + CANAL_COMUNICACION_SMS + "']").prop('checked',true);
						$("#tfnoNot00_tabSolicitud_detail_table").val(data.tlfnoServicio01);
						
					//}
					
					if($("#T_idTipoNot00_tabSolicitud_detail_table").is(':checked')){
						$("#divDireccionNot").hide();
					}else if($("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked')){
						$("#divDireccionNot").show();
						
					}
					if($("#T_idTipoNot00_tabSolicitud_detail_table").is(':checked')){
							if($("#A_canalNot00_tabSolicitud_detail_table").is(':checked')){
								$("#tlfnNotGrupo").show();
								$("#emailNotGrupo").show();
							}if($("#E_canalNot00_tabSolicitud_detail_table").is(':checked')){
								$("#emailNotGrupo").show();
								$("#tlfnNotGrupo").hide();
							}if($("#S_canalNot00_tabSolicitud_detail_table").is(':checked')){
								$("#tlfnNotGrupo").show();
								$("#emailNotGrupo").hide();
							}
						
					}else if($("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked')){
							if($("#A_canalNot00_tabSolicitud_detail_table").is(':checked')){
								$("#tlfnNotGrupo").show();
								$("#emailNotGrupo").show();
							}if($("#E_canalNot00_tabSolicitud_detail_table").is(':checked')){
								$("#emailNotGrupo").show();
								$("#tlfnNotGrupo").hide();
							}if($("#S_canalNot00_tabSolicitud_detail_table").is(':checked')){
								$("#tlfnNotGrupo").show();
								$("#emailNotGrupo").hide();
							}
						$("#divDireccionNot").show();
						
					}else{
						$("#divDireccionNot").hide();
						$("#emailNotGrupo").hide();
						$("#tlfnNotGrupo").hide();
					}
					console.log("Iniciar dirección de notificación");						
					
					//Ya que parte de los datos migrados no tiene ultimo expediente y al lanzar las bajas no se está completando bien
					//const dirNotif = data.ultimoExpediente != null ? (data.ultimoExpediente.direccionNotif != null  &&  data.ultimoExpediente.direccionNotif.idDireccion06 != null) ? data.ultimoExpediente.direccionNotif : data.direcciones : data.direcciones ;
					const dirNotif = data.direcciones ;
					iniciarDireccionNotificacion(dirNotif, "dirNot");
					
					if(dirNotif.portal06!=null){
						$('#dirNotportal06_detail_table').val(dirNotif.portal06);
					}
					if(dirNotif.calle06!=null){
						$('#dirNotcaltable06_detail_table').val(dirNotif.calle06);
					}
				}
				else{							
					$('.datosNuevoBeneficiario').show();
					
					$("#buscarSolicitanteBtn i").fadeOut();
					$("#buscarSolicitanteBtn i").removeClass("mdi-magnify");
					$("#buscarSolicitanteBtn i").addClass("mdi-close rojo");
					$("#buscarSolicitanteBtn i").fadeIn();
					
					setTimeout(() => {
						$("#buscarSolicitanteBtn i").fadeOut();
						$("#buscarSolicitanteBtn i").addClass("mdi-magnify");
						$("#buscarSolicitanteBtn i").removeClass("mdi-close rojo");
						$("#buscarSolicitanteBtn i").fadeIn();
					}, 2000);
					
					if(data.idSolicitante01 != null){
						$("#iniciosOficio_feedback").rup_feedback("set", $.rup.i18n.app.avisos.beneficiarioNoEncontrado, "error");
					}else{
						$("#iniciosOficio_feedback").rup_feedback('set',$.rup.i18n.app.errores.dniNoEncontrado,"error");	
					}
					
					$('#iniciarOficio_detail_button_save').prop("disabled",true);
					if($("#idProcedimiento00_observacionesOficio_detail_table").val() == '0087007'){
						limpiarLiquidaciones();
					}
					$('#nombre01_informes_dialog_table').val(data.nombre01);
					$('#apellido101_informes_dialog_table').val(data.apellido101);
					$('#apellido201_informes_dialog_table').val(data.apellido201);
					$("#tfnoNot00_tabSolicitud_detail_table").val(data.tlfnoServicio01);
					$("#dirNotcp06_detail_table").val("");
					$("#dirNotportal06_detail_table").val("");
					$("#dirNotcalle06_detail_table").val("");
					$("#dirNotlocalidad06_detail_table").val("");
					$("#dirNotescalera06_detail_table").val("");
					$("#dirNotpiso06_detail_table").val("");
					$("#dirNotletra06_detail_table").val("");
					iniciarDireccionNotificacion(expedienteJSON.direccionNotif, "dirNot");
				}
				Ad74aUtils.desBloquearInterfaz();
              },
              error: function(error){ 
				Ad74aUtils.desBloquearInterfaz();
				alert("error")
		      }

        });	 
	  }
};
function obtenerLiquidacionesSolicitante(){
	const url = $.rup.CTX_PATH + "inicioOficio/obtenerLiquidacionesSolicitante/"+$('#dniSolicitante_informes_dialog_table').val();
	
	 $.rup_ajax({
			url: url,
			type: 'POST',
			contentType: 'application/json',
			dataType: 'json',
			success: function (res) {
				if(res==null){
					//mostrar error de que no tiene liquidaciones
					limpiarLiquidaciones();
					$("#liquidaciones_feedback").rup_feedback("set", $.rup.i18n.app.errores.notificacionLiquidacion,"error");
				}		
	 			else if(res.length>1){
					//$("#datosLiq").show();
					//show lupita
					$("#buscarLiquidacionBtn").show();
					//$("#layerLiquidacion").hide();
					$("#liquidaciones_feedback").rup_feedback("set", $.rup.i18n.app.avisos.notificacionLiquidacion,"alert");
					//$("#liquidaciones_table").attr("data-url-base", $.rup.CTX_PATH  + "inicioOficio/liquidacionesSolicitante/"+$('#dniSolicitante_informes_dialog_table').val());
					//$("#liquidaciones_table").attr("url", $.rup.CTX_PATH  + "inicioOficio/liquidacionesSolicitante/"+$('#dniSolicitante_informes_dialog_table').val());
					//cargarTablaLiquidaciones();
					$('#liquidaciones').rup_table('reload');
					$("#layerEnlaceverPago").hide();
					//$("#verPago").attr("href",url_pago);
				}else if(res.length==1){
					//$("#datosLiq").show();
					//cargar datos
					var datosLiq=res[0];
					$("#referenciaLiq00_liquidaciones_dialog_table").val(datosLiq.referenciaLiq00);
					$("#concepto00_liquidaciones_dialog_table").val(datosLiq.concepto00);
					$("#importe00_liquidaciones_dialog_table").val(datosLiq.importe00);
					$("#fEmision00_liquidaciones_dialog_table").val(datosLiq.fEmision00);
					$("#fLimitePago00_liquidaciones_dialog_table").val(datosLiq.fLimitePago00);
					$("#idLiquidacion00").val(datosLiq.idLiquidacion00);
					
					//hide lupita

					$("#verPago").attr("href",url_pago+datosLiq.idLiquidacion00);
					$("#buscarLiquidacionBtn").hide();
					$("#layerEnlaceverPago").show();
					$('#tablaLiq').hide();
					
					$("#liquidaciones_feedback").rup_feedback("set", $.rup.i18n.app.avisos.notificacionLiquidacion,"alert");
				}else{
					//mostrar error de que no tiene liquidaciones
					limpiarLiquidaciones();
					$("#liquidaciones_feedback").rup_feedback("set", $.rup.i18n.app.errores.notificacionLiquidacion,"error");
					//$("#verPago").attr("href",url_pago);
					
				}
			},
			error: function (error) {
				console.log(error);
				//$("#iniciosOficio_feedback").rup_feedback('set', error.responseText, "error");	
			}
		});
		
	/*$.rup_ajax(ajaxData);*/
}

function limpiarLiquidaciones(){
	$("#referenciaLiq00_liquidaciones_dialog_table").val("");
	$("#concepto00_liquidaciones_dialog_table").val("");
	$("#importe00_liquidaciones_dialog_table").val("");
	$("#fEmision00_liquidaciones_dialog_table").val("");
	$("#fLimitePago00_liquidaciones_dialog_table").val("");
	//$("#datosLiq").hide();
	$("#liquidaciones_feedback").rup_feedback("set", $.rup.i18n.app.avisos.notificacionLiquidacion,"alert");
	//enrutar el enlace
	//$("#verPago").attr("href",url_pago);
	$("#buscarLiquidacionBtn").hide();
	$("#layerEnlaceverPago").hide();
	$('#tablaLiq').hide();
}

$("#buscarLiquidacionBtn").on('click', () => {

	 $("#buscarLiquidacionBtn").blur();
	 $("#buscarLiquidacionBtn").hide();
	 //$("#verPagoBtn").show();
	 $('#tablaLiq').show();
	 $("#verPagoBtn").hide();
});

function validarDocLiq () {
	var respuesta=false;
	if($("#idProcedimiento00_observacionesOficio_detail_table").val() == '0087007'){
		var dataDocs=$("#documento_table").rup_table("getContext").json.rows;
		for(i=0;i<dataDocs.length;i++){
			var tipoDoc=dataDocs[i].roleID;
			if("ejgv_d_liquidacion.0.0"==tipoDoc)
				respuesta=true;
		}
	}else{
		respuesta= true;
	}
	return respuesta;
}